#include <ESP8266WiFi.h>
#include <ThingESP.h>
ThingESP8266 thing("agaseptimaulana", "vandingmachine", "vandingmachineobat");
#include <SPI.h>
#include <MFRC522.h>
#include<LiquidCrystal_I2C.h>
#include <Servo.h>
#define RST_PIN  D0
#define SS_PIN   D4
LiquidCrystal_I2C lcd(0x27, 16, 2);
MFRC522 mfrc522(SS_PIN, RST_PIN);
Servo servo1, servo2, servo3;

void setup() {
  Serial.begin(115200);
  SPI.begin();      // Initiate  SPI bus
  mfrc522.PCD_Init();   // Initiate MFRC522
  lcd.init();
  lcd.backlight();
  servo1.attach(0);
  servo1.write(40);
  delay(100);
  servo2.attach(15);
  servo2.write(60);
  delay(100);
  servo3.attach(3);
  servo3.write(45);
  delay(100);
  thing.SetWiFi("wireless@umsida.ac.id", "AhmadDahlan1868");
  thing.initDevice();
}

void loop() {
  thing.Handle();
  lcd.setCursor(3, 0);
  lcd.print("PROTOTYPE");
  lcd.setCursor(0, 1);
  lcd.print("Vending Machine");
  // Look for new cards
  if ( ! mfrc522.PICC_IsNewCardPresent())
  {
    return;
  }
  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial())
  {
    return;
  }
  //Show UID on serial monitor
  Serial.println();
  Serial.print(" UID tag :");
  String content = "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++)
  {
    Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
    Serial.print(mfrc522.uid.uidByte[i], HEX);
    content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
    content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  content.toUpperCase();
  Serial.println();
  if (content.substring(1) == "BE D0 36 7A") //change UID of the card that you want to give access
  {
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("Pengambilan");
    lcd.setCursor(1, 1);
    lcd.print("Obat Diabetes");
    servo1.write(90);
    //yield();
    //mybot.sendMessage(id, "Pengambilan obat penyakit diabetes telah diambil!");
    String msg = "Pengambilan obat penyakit diabetes telah diambil!";
    thing.sendMsg("6281217166593", msg);
    delay(1000);
    servo1.write(40);
    lcd.clear();
  }
  else if (content.substring(1) == "5E 96 36 7A") //change UID of the card that you want to give access
  {
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("Pengambilan");
    lcd.setCursor(2, 1);
    lcd.print("Obat Jantung");
    servo2.write(105);
    //yield();
    //mybot.sendMessage(id, "Pengambilan obat penyakit jantung telah diambil!");
    String msg = "Pengambilan obat penyakit jantung telah diambil!";
    thing.sendMsg("6281217166593", msg);
    delay(3000);
    servo2.write(60);
    lcd.clear();
  }
  else if (content.substring(1) == "FE 0C 36 7A") //change UID of the card that you want to give access
  {
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("Pengambilan");
    lcd.setCursor(0, 1);
    lcd.print("Obat Hipertensi");
    servo3.write(90);
    //yield();
    //mybot.sendMessage(id, "Pengambilan obat penyakit hipertensi telah diambil!");
    String msg = "Pengambilan obat penyakit hipertensi telah diambil!";
    thing.sendMsg("6281217166593", msg);
    delay(1000);
    servo3.write(45);
    lcd.clear();
  }
  else   {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Access Denied");
    //mybot.sendMessage(id, "Kartu tidak terdaftar, obat tidak dikeluarkan");
    String msg = "Kartu tidak terdaftar, obat tidak dikeluarkan";
    thing.sendMsg("6281217166593", msg);
    delay(1000);
    lcd.clear();
  }
}
